from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  pipefail = 3
  inherit_errexit = 4
  nullglob = 5
  verbose_errexit = 6
  noexec = 7
  xtrace = 8
  verbose = 9
  noglob = 10
  noclobber = 11
  posix = 12
  vi = 13
  emacs = 14
  interactive = 15
  hashall = 16
  failglob = 17
  extglob = 18
  eval_unsafe_arith = 19
  _allow_command_sub = 20
  _allow_process_sub = 21
  dynamic_scope = 22
  redefine_module = 23
  _running_trap = 24
  _running_hay = 25
  strict_argv = 26
  strict_arith = 27
  strict_array = 28
  strict_control_flow = 29
  strict_errexit = 30
  strict_nameref = 31
  strict_word_eval = 32
  strict_tilde = 33
  strict_glob = 34
  parse_at = 35
  parse_proc = 36
  parse_func = 37
  parse_brace = 38
  parse_equals = 39
  parse_paren = 40
  parse_raw_string = 41
  parse_triple_quote = 42
  simple_word_eval = 43
  dashglob = 44
  expand_aliases = 45
  command_sub_errexit = 46
  process_sub_fail = 47
  xtrace_rich = 48
  xtrace_details = 49
  sigpipe_status_ok = 50
  redefine_proc_func = 51
  parse_at_all = 52
  parse_backslash = 53
  parse_backticks = 54
  parse_dollar = 55
  parse_ignored = 56
  parse_sh_arith = 57
  parse_sh_assign = 58
  parse_dparen = 59
  parse_bare_word = 60
  simple_echo = 61
  simple_eval_builtin = 62
  simple_test_builtin = 63
  parse_tea = 64
  lastpipe = 65
  progcomp = 66
  histappend = 67
  hostcomplete = 68
  cmdhist = 69
  assoc_expand_once = 70
  autocd = 71
  cdable_vars = 72
  cdspell = 73
  checkhash = 74
  checkjobs = 75
  checkwinsize = 76
  complete_fullquote = 77
  direxpand = 78
  dirspell = 79
  dotglob = 80
  execfail = 81
  extdebug = 82
  extquote = 83
  force_fignore = 84
  globasciiranges = 85
  globstar = 86
  gnu_errfmt = 87
  histreedit = 88
  histverify = 89
  huponexit = 90
  interactive_comments = 91
  lithist = 92
  localvar_inherit = 93
  localvar_unset = 94
  login_shell = 95
  mailwarn = 96
  no_empty_cmd_completion = 97
  nocaseglob = 98
  nocasematch = 99
  progcomp_alias = 100
  promptvars = 101
  restricted_shell = 102
  shift_verbose = 103
  sourcepath = 104
  xpg_echo = 105
  ARRAY_SIZE = 106

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.pipefail',
  4: 'option.inherit_errexit',
  5: 'option.nullglob',
  6: 'option.verbose_errexit',
  7: 'option.noexec',
  8: 'option.xtrace',
  9: 'option.verbose',
  10: 'option.noglob',
  11: 'option.noclobber',
  12: 'option.posix',
  13: 'option.vi',
  14: 'option.emacs',
  15: 'option.interactive',
  16: 'option.hashall',
  17: 'option.failglob',
  18: 'option.extglob',
  19: 'option.eval_unsafe_arith',
  20: 'option._allow_command_sub',
  21: 'option._allow_process_sub',
  22: 'option.dynamic_scope',
  23: 'option.redefine_module',
  24: 'option._running_trap',
  25: 'option._running_hay',
  26: 'option.strict_argv',
  27: 'option.strict_arith',
  28: 'option.strict_array',
  29: 'option.strict_control_flow',
  30: 'option.strict_errexit',
  31: 'option.strict_nameref',
  32: 'option.strict_word_eval',
  33: 'option.strict_tilde',
  34: 'option.strict_glob',
  35: 'option.parse_at',
  36: 'option.parse_proc',
  37: 'option.parse_func',
  38: 'option.parse_brace',
  39: 'option.parse_equals',
  40: 'option.parse_paren',
  41: 'option.parse_raw_string',
  42: 'option.parse_triple_quote',
  43: 'option.simple_word_eval',
  44: 'option.dashglob',
  45: 'option.expand_aliases',
  46: 'option.command_sub_errexit',
  47: 'option.process_sub_fail',
  48: 'option.xtrace_rich',
  49: 'option.xtrace_details',
  50: 'option.sigpipe_status_ok',
  51: 'option.redefine_proc_func',
  52: 'option.parse_at_all',
  53: 'option.parse_backslash',
  54: 'option.parse_backticks',
  55: 'option.parse_dollar',
  56: 'option.parse_ignored',
  57: 'option.parse_sh_arith',
  58: 'option.parse_sh_assign',
  59: 'option.parse_dparen',
  60: 'option.parse_bare_word',
  61: 'option.simple_echo',
  62: 'option.simple_eval_builtin',
  63: 'option.simple_test_builtin',
  64: 'option.parse_tea',
  65: 'option.lastpipe',
  66: 'option.progcomp',
  67: 'option.histappend',
  68: 'option.hostcomplete',
  69: 'option.cmdhist',
  70: 'option.assoc_expand_once',
  71: 'option.autocd',
  72: 'option.cdable_vars',
  73: 'option.cdspell',
  74: 'option.checkhash',
  75: 'option.checkjobs',
  76: 'option.checkwinsize',
  77: 'option.complete_fullquote',
  78: 'option.direxpand',
  79: 'option.dirspell',
  80: 'option.dotglob',
  81: 'option.execfail',
  82: 'option.extdebug',
  83: 'option.extquote',
  84: 'option.force_fignore',
  85: 'option.globasciiranges',
  86: 'option.globstar',
  87: 'option.gnu_errfmt',
  88: 'option.histreedit',
  89: 'option.histverify',
  90: 'option.huponexit',
  91: 'option.interactive_comments',
  92: 'option.lithist',
  93: 'option.localvar_inherit',
  94: 'option.localvar_unset',
  95: 'option.login_shell',
  96: 'option.mailwarn',
  97: 'option.no_empty_cmd_completion',
  98: 'option.nocaseglob',
  99: 'option.nocasematch',
  100: 'option.progcomp_alias',
  101: 'option.promptvars',
  102: 'option.restricted_shell',
  103: 'option.shift_verbose',
  104: 'option.sourcepath',
  105: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  builtin = 10
  readonly = 11
  local = 12
  declare = 13
  typeset = 14
  export_ = 15
  test = 16
  bracket = 17
  true_ = 18
  false_ = 19
  try_ = 20
  read = 21
  echo = 22
  printf = 23
  mapfile = 24
  readarray = 25
  cd = 26
  pushd = 27
  popd = 28
  dirs = 29
  pwd = 30
  source = 31
  umask = 32
  wait = 33
  jobs = 34
  fg = 35
  bg = 36
  shopt = 37
  complete = 38
  compgen = 39
  compopt = 40
  compadjust = 41
  getopts = 42
  command = 43
  type = 44
  hash = 45
  help = 46
  history = 47
  alias = 48
  unalias = 49
  bind = 50
  append = 51
  write = 52
  json = 53
  j8 = 54
  pp = 55
  hay = 56
  haynode = 57
  module = 58
  use = 59
  fork = 60
  forkwait = 61
  fopen = 62
  shvar = 63
  runproc = 64
  boolstatus = 65
  argparse = 66
  describe = 67
  push_registers = 68
  cat = 69
  ARRAY_SIZE = 70

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.builtin',
  11: 'builtin.readonly',
  12: 'builtin.local',
  13: 'builtin.declare',
  14: 'builtin.typeset',
  15: 'builtin.export_',
  16: 'builtin.test',
  17: 'builtin.bracket',
  18: 'builtin.true_',
  19: 'builtin.false_',
  20: 'builtin.try_',
  21: 'builtin.read',
  22: 'builtin.echo',
  23: 'builtin.printf',
  24: 'builtin.mapfile',
  25: 'builtin.readarray',
  26: 'builtin.cd',
  27: 'builtin.pushd',
  28: 'builtin.popd',
  29: 'builtin.dirs',
  30: 'builtin.pwd',
  31: 'builtin.source',
  32: 'builtin.umask',
  33: 'builtin.wait',
  34: 'builtin.jobs',
  35: 'builtin.fg',
  36: 'builtin.bg',
  37: 'builtin.shopt',
  38: 'builtin.complete',
  39: 'builtin.compgen',
  40: 'builtin.compopt',
  41: 'builtin.compadjust',
  42: 'builtin.getopts',
  43: 'builtin.command',
  44: 'builtin.type',
  45: 'builtin.hash',
  46: 'builtin.help',
  47: 'builtin.history',
  48: 'builtin.alias',
  49: 'builtin.unalias',
  50: 'builtin.bind',
  51: 'builtin.append',
  52: 'builtin.write',
  53: 'builtin.json',
  54: 'builtin.j8',
  55: 'builtin.pp',
  56: 'builtin.hay',
  57: 'builtin.haynode',
  58: 'builtin.module',
  59: 'builtin.use',
  60: 'builtin.fork',
  61: 'builtin.forkwait',
  62: 'builtin.fopen',
  63: 'builtin.shvar',
  64: 'builtin.runproc',
  65: 'builtin.boolstatus',
  66: 'builtin.argparse',
  67: 'builtin.describe',
  68: 'builtin.push_registers',
  69: 'builtin.cat',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

